/* Script generated by Pawn Studio */

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <engine>
#include <xs>
#include <codmod>

#define PLUGIN	"codModMinecraftExp"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

forward cod_exp_kill( id , iKilled , iExp );
forward cod_exp_damage( id , iKilled , iExp );

new const szModelOrb[ ]			=	"sprites/orb.spr";
new const szOrbClassName[ ]		=	"orb";
new const Float: fFrameRate		=	10.0;
new const Float: fStandardScale	=	0.07;
new const szOrbSound[ ]			=	"sound/orb.mp3";

new pCvarHowMany ,
	pCvarEqual,
	pCvarDistance,
	pCvarMinimumDistance,
	pCvarSpeed,
	pCvarOnlyOwner,
	pCvarTeam,
	pCvarOnlyYou;

public plugin_init(){
	register_plugin( PLUGIN , VERSION , AUTHOR )
	
	register_think( szOrbClassName , "thinkOrb" );
	
	pCvarHowMany			=	register_cvar( "orbExp_howMany" , "2-4" );
	pCvarEqual				=	register_cvar( "orbExp_equal" , "0" );
	pCvarDistance			=	register_cvar( "orbExp_distance" , "400.0" );
	pCvarMinimumDistance	=	register_cvar( "orbExp_minimum" ,"40.0" );
	pCvarSpeed				=	register_cvar( "orbExp_speed" , "100.0" );
	pCvarOnlyOwner			=	register_cvar( "orbExp_onlyowner" , "1" );
	pCvarTeam				=	register_cvar( "orbExp_team" , "1" );
	pCvarOnlyYou			=	register_cvar( "orbExp_onlyYou" , "1" );
	
	register_cvar( "orbExp_damageOn" , "0" );
	register_cvar( "orbExp_killOn" , "1" );
	
	register_event( "HLTV", "Nowa_Runda", "a", "1=0", "2=0" );
}

public plugin_cfg(){
	new bool: bDamage	=	bool: get_cvar_num( "orbExp_damageOn" );
	new bool: bKill		=	bool: get_cvar_num( "orbExp_killOn" );
	
	if( bDamage && bKill ){
		state both;
	}
	else if( bDamage && !bKill ){
		state onlyDamage;
	}
	else{
		state onlyKill;
	}
	
	if( get_pcvar_num( pCvarOnlyYou ) ){
		register_forward( FM_AddToFullPack , "fwAddToFullPack" , 1 );
	}
}

public plugin_precache(){
	precache_model( szModelOrb );
	precache_generic( szOrbSound );
}

public cod_exp_damage( id , iKilled , iExp ) < both , onlyDamage > {
	return orbCalculate( id , iKilled , iExp );
}

public cod_exp_damage( id , iKilled , iExp ) < onlyKill > {
	return PLUGIN_CONTINUE;
}

public cod_exp_kill( id , iKilled , iExp ) < both , onlyKill > {
	return orbCalculate( id , iKilled , iExp );
}

public cod_exp_kill( id , iKilled , iExp ) < onlyDamage > {
	return PLUGIN_CONTINUE;
}

orbCalculate( id , iKilled , iExp ){
	if( iExp <=	0 ){
		return PLUGIN_CONTINUE;
	}
	
	new iMin	=	0,
	iMax	=	0;
	
	new szHowMany[ 16 ];
	
	get_pcvar_string( pCvarHowMany , szHowMany , charsmax( szHowMany ) );
	
	if( contain( szHowMany , "-" ) != -1 ){
		replace_all( szHowMany , charsmax( szHowMany ) , "-" , " " );
		
		new szMin[ 8 ],
		szMax[ 8 ];
		
		parse( szHowMany , szMin , charsmax( szMin ) , szMax , charsmax( szMax ) );
		
		iMin	=	str_to_num( szMin );
		iMax	=	str_to_num( szMax );
	}
	else {
		iMin	=	str_to_num( szHowMany );
		iMax	=	iMin;
	}
	
	if( iMin < 0 ){
		iMin	=	0;
	}
	
	if( iMax <= 0 || iMax < iMin ){
		return PLUGIN_CONTINUE;
	}
	
	new	iAmount	=	random_num( iMin , iMax );
	
	if( iAmount <= 0 ){
		return PLUGIN_CONTINUE;
	}
	
	if( get_pcvar_num( pCvarEqual ) ){
		new iExpAmount	=	iExp / iAmount;
		
		if( iExpAmount <= 0 ){
			return PLUGIN_CONTINUE;
		}
		
		new Float: fPosition[ 3 ];
		
		pev( iKilled , pev_origin , fPosition );
		
		for( new i	=	0 ; i < iAmount ; i++ ){
			createOrb( id , fPosition , szModelOrb , fStandardScale , iExpAmount );
		}
	}
	else {
		new iExpTmp			=	iExp;
		new iExpAmount		=	0;
		new Float: fScale	=	1.0;
		
		new Float: fPosition[ 3 ];
		
		pev( iKilled , pev_origin , fPosition );
		
		for( new i	=	0 ; i < iAmount ; i++ ){
			if( i	==	iAmount - 1 ){
				iExpAmount	=	iExpTmp;
			}
			else{
				iExpAmount	=	random_num( 1 , iExpTmp / 2 );
			}
			
			iExpTmp	-=	iExpAmount;
			
			if( iExpTmp < 0 ){
				break;
			}
			
			fScale	=	( float( iExpAmount ) / float( iExp ) ) * fStandardScale ;
			
			createOrb( id , fPosition , szModelOrb , fScale , iExpAmount );
		}
	}
	
	return PLUGIN_HANDLED;
}

public thinkOrb( iEnt ){
	if( !pev_valid( iEnt ) ){
		return PLUGIN_CONTINUE;
	}
	
	new iNearest				=	0,
		Float: fDistance		=	0.0,
		Float: fNearDistance	=	9999.0;
	
	if( get_pcvar_num( pCvarOnlyOwner ) ){
		new iPlayer	=	pev( iEnt , pev_iuser2 );
		
		if( !is_user_alive( iPlayer ) ){
			remove_entity( iEnt );
			
			return PLUGIN_CONTINUE;
		}
		
		fDistance	=	entity_range( iEnt , iPlayer );
		
		if( fDistance <= get_pcvar_float( pCvarDistance ) ){
			iNearest		=	iPlayer;
			fNearDistance	=	fDistance;
		}
	}
	else {
		new iTeam;
		
		new iPlayer	=	pev( iEnt , pev_iuser2 );
		
		if( get_pcvar_num( pCvarTeam ) ){
			if( !is_user_connected( iPlayer ) || get_user_team( iPlayer ) == 3 ){
				iTeam	=	0;
			}
			else{
				iTeam	=	get_user_team( iPlayer );
			}
		}
		else{
			iTeam	=	0;
		}
		
		for( new i = 1 ; i < get_maxplayers() ; i++ ){
			if( !is_user_alive( i ) || ( iTeam != 0 && iTeam != get_user_team( i ) ) ){
				continue;
			}
			
			fDistance	=	entity_range( iEnt , i );
			
			if( fDistance < fNearDistance && fDistance <= get_pcvar_float( pCvarDistance ) ){
				fNearDistance	=	fDistance;
				
				iNearest	=	i;
			}
		}
	}
	
	if( !is_user_alive( iNearest ) ){
		set_pev( iEnt , pev_nextthink , get_gametime() + 0.1 );
			
		return PLUGIN_CONTINUE;
	}
	
	if( fNearDistance <= get_pcvar_float( pCvarMinimumDistance ) ){
		if( pev( iEnt , pev_movetype ) != MOVETYPE_FLY ){
			set_pev( iEnt , pev_movetype , MOVETYPE_FLY );
		}
		
		calcVelocity( iEnt , iNearest , true );
	}
	else{
		if( pev( iEnt , pev_movetype ) != MOVETYPE_STEP ){
			set_pev( iEnt , pev_movetype , MOVETYPE_STEP );
		}
		
		calcVelocity( iEnt , iNearest );
	}
	
	if( fNearDistance <= 3.0 ){
		cod_set_user_xp( iNearest , cod_get_user_xp( iNearest ) + pev( iEnt , pev_iuser1 ) );
			
		remove_entity( iEnt );
		
		playSound( iNearest );
		
		return PLUGIN_CONTINUE;
	}
	
	set_pev( iEnt , pev_nextthink , get_gametime() + 0.1 );
	
	return PLUGIN_CONTINUE;
}

calcVelocity( iEnt , id , bool: zAxis	=	false){
	new Float: fVeloc[ 3 ] ,
	Float: fOriginEnt[ 3 ],
	Float: fOriginPlayer[ 3 ];
	
	
	pev( iEnt , pev_origin , fOriginEnt );
	pev( id,  pev_origin , fOriginPlayer );
	
	if( !zAxis ){
		fOriginEnt[ 2 ]		=	0.0;
		fOriginPlayer[ 2 ]	=	0.0;
	}
	
	xs_vec_sub( fOriginPlayer , fOriginEnt , fVeloc );
	
	xs_vec_normalize( fVeloc , fVeloc );
	
	xs_vec_mul_scalar( fVeloc , get_pcvar_float( pCvarSpeed ) , fVeloc );
	
	set_pev( iEnt , pev_velocity , fVeloc );
}

createOrb( iOwner , Float: fPosition[ 3 ] , const szModel[ ] , Float: fScale =	0.05 , iExp ){
	new iEnt	=	engfunc( EngFunc_CreateNamedEntity , engfunc( EngFunc_AllocString , "env_sprite" ) );
	
	if( !pev_valid( iEnt ) ){
		return PLUGIN_CONTINUE;
	}
	
	set_pev( iEnt , pev_classname , szOrbClassName );
	
	set_pev( iEnt , pev_scale , fScale );
	
	set_pev( iEnt , pev_iuser1 , iExp );
	set_pev( iEnt , pev_iuser2 , iOwner );
	
	set_pev( iEnt , pev_framerate , fFrameRate );
	
	set_pev( iEnt , pev_spawnflags , SF_SPRITE_STARTON )
	
	set_pev( iEnt , pev_nextthink , get_gametime() + 0.1 );
	
	set_pev( iEnt , pev_model , szModel );
	
	DispatchSpawn( iEnt );
	
	set_pev( iEnt , pev_solid , SOLID_TRIGGER );
	set_pev( iEnt , pev_movetype , MOVETYPE_STEP );
	set_pev( iEnt , pev_gravity , 1.0 );
	
	engfunc( EngFunc_SetSize, iEnt , Float:{-1.0, -1.0, -6.0} , Float:{1.0, 1.0, 6.0} );
	engfunc( EngFunc_SetOrigin , iEnt , fPosition );
	
	set_task( 0.1 , "velocRandom" , iEnt );
	
	return PLUGIN_CONTINUE;
}

public velocRandom( iEnt ){
	if( !pev_valid( iEnt ) ){
		return ;
	}
	
	new Float: fVeloc[ 3 ];
	
	fVeloc[ 0 ]	=	random_float( 0.0 , 150.0 );
	fVeloc[ 1 ]	=	random_float( 0.0 , 150.0 );
	fVeloc[ 2 ]	=	random_float( 0.0 , 150.0 );
	
	set_pev( iEnt , pev_velocity , fVeloc );
}

playSound( id ){
	client_cmd( id , "mp3 play ^"%s^"" , szOrbSound );
}

public Nowa_Runda(){
	remove_entity_name( szOrbClassName );
}

public fwAddToFullPack(es_handle, e, ENT, HOST, hostflags, player, set){
	if( player || !pev_valid( ENT ) )	return	FMRES_IGNORED;
	
	if( !get_pcvar_num( pCvarOnlyOwner ) ){
		return FMRES_IGNORED;
	}
	
	static szClassName[ 64 ];
	
	pev( ENT , pev_classname , szClassName , charsmax( szClassName ) );
	
	if( !equal( szClassName , szOrbClassName ) ){
		return FMRES_IGNORED;
	}
	
	if( HOST != pev( ENT,pev_iuser2 ) ){
		set_es( es_handle ,	ES_RenderAmt , 0 );
		set_es( es_handle , ES_RenderMode , kRenderTransAdd );
	}
	
	return FMRES_HANDLED;
}
